uint threshold;
uint inputCount;
Texture2D<float4> InputTexture;

StructuredBuffer<float>areas;
StructuredBuffer<float2>zRanges;
StructuredBuffer<float4>colors;

RWTexture2D<float4> OutputTexture : BACKBUFFER;
AppendStructuredBuffer<int> OutputValues : BACKBUFFER2;

cbuffer cbSettings : register(b0)
{
	float4 bg <bool color=true;>;
	int writeX;
	int writeY;
}

[numthreads(8,8,1)]
void CS(uint3 tid : SV_DispatchThreadID)
{
	
	if(tid.x * tid.y >= inputCount)
		return;
	
	float4 tex = InputTexture[tid.xy];
	float2 uv = tid.xy;	
	float4 col = float4(0,0,0,1);	
	
	float area;
	float range;
	float hit;
	uint hits;

	int button[16]; //hardcoded
	
	uint count, stride;
	areas.GetDimensions(count, stride);		
	
	for(uint i = 0; i < count-1; i++) 
	{		
		float2 zRange = zRanges[i];
		hits = 0;
		
		area = step(areas[i], uv.x) * step(uv.x, areas[i+1]);	// alle pixel zwischen aktuellem und nchstem "area" x wert
		range =  step(zRange.x, tex.b) * (1 - step(zRange.y, tex.b));	// alle pixel innerhalb des aktuellen zThresholds
		
		hit = area * range; //hit = alle zTrigger innerhalb des aktuellen Buttons
		hits += hit; //increment hits counter
		
		
		col.rgb += colors[i].rgb * hit;	//helper
		
		if(hits > threshold) // wenn hitscounter > threshold dann button = 1
			button[i] = 1;
		
		// irgendwie raus schreiben?		
		
		//OutputValues.Append(1);
		
	
	}		
	
	OutputTexture[tid.xy+int2(writeX, writeY)] = col;
	
	//OutputValues[tid.x] = hits[tid.x];
	
}

technique11 Apply
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}




